//+------------------------------------------------------------------+
//|                                                TradeReceiver.mq4 |
//|                                    Copyright  2008, fxtrader625 |
//|                                  http://www.forexampletrades.com |
//|                            Donation: paypal@forexampletrades.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, fxtrader625"
#property link      "http://www.forexampletrades.com"

#import "TradeSwitch.dll"
int FlushSignal(string Name);
string ReceiveSignal(string Name);
#import

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   int cmd;
   int magic;
   int ticket;
   double volume;
   double price;
   double stoploss;
   double takeprofit;
   string symbol;
   string message = "";
   
   message = ReceiveSignal(Symbol());

   while (StringLen(message) > 0)
   {
      if (StringFind(message,"OrderSend") == 0)
      {
         if (ParseOrderSend(message,cmd,volume,price,stoploss,takeprofit,magic))
         {
            OrderSend(Symbol(),cmd,volume,price,3,stoploss,takeprofit,NULL,magic);
         }
      }
      else if (StringFind(message,"OrderModify") == 0)
      {
         if (ParseOrderModify(message,ticket,price,stoploss,takeprofit))
         {
            OrderModify(ticket,price,stoploss,takeprofit,0);
         }
      }
      else if (StringFind(message,"OrderClose") == 0)
      {
         if (ParseOrderClose(message,ticket,volume,price))
         {
            OrderClose(ticket,volume,price,3);
         }
      }
      else if (StringFind(message,"OrderDelete") == 0)
      {
         if (ParseOrderDelete(message,ticket))
         {
            OrderDelete(ticket);
         }
      }
      
      message = ReceiveSignal(Symbol());
   }
   
   message = ReceiveSignal(AccountNumber());
   
   while (StringLen(message) > 0)
   {
      if (StringFind(message,"OrderSend") == 0)
      {
         if (ParseSymbolOrderSend(message,symbol,cmd,volume,price,stoploss,takeprofit,magic))
         {
            OrderSend(symbol,cmd,volume,price,3,stoploss,takeprofit,NULL,magic);
         }
      }
      else if (StringFind(message,"OrderModify") == 0)
      {
         if (ParseOrderModify(message,ticket,price,stoploss,takeprofit))
         {
            OrderModify(ticket,price,stoploss,takeprofit,0);
         }
      }
      else if (StringFind(message,"OrderClose") == 0)
      {
         if (ParseOrderClose(message,ticket,volume,price))
         {
            OrderClose(ticket,volume,price,3);
         }
      }
      else if (StringFind(message,"OrderDelete") == 0)
      {
         if (ParseOrderDelete(message,ticket))
         {
            OrderDelete(ticket);
         }
      }
      
      message = ReceiveSignal(AccountNumber());
   }
   
   return(0);
}

bool ParseOrderSend(string text, int& cmd, double& volume, double& price, double& stoploss, double& takeprofit, int& magic)
{
   int index = StringFind(text,",");
   text = StringSubstr(text,index+1);
   index = StringFind(text,",");
   if (index > 0)
   {
      // Parse ordertype
      string cmdstring = StringSubstr(text,0,index);
      if (StringFind(cmdstring,"OP_BUYSTOP") == 0) cmd = OP_BUYSTOP;
      else if (StringFind(cmdstring,"OP_SELLSTOP") == 0) cmd = OP_SELLSTOP;
      else if (StringFind(cmdstring,"OP_BUYLIMIT") == 0) cmd = OP_BUYLIMIT;
      else if (StringFind(cmdstring,"OP_SELLLIMIT") == 0) cmd = OP_SELLLIMIT;
      else if (StringFind(cmdstring,"OP_BUY") == 0) cmd = OP_BUY;
      else if (StringFind(cmdstring,"OP_SELL") == 0) cmd = OP_SELL;
      else return(false);
      text = StringSubstr(text,index+1);
      index = StringFind(text,",");
      if (index > 0)
      {
         // volume
         string volumestring = StringSubstr(text,0,index);
         volume = StrToDouble(volumestring);
         if (volume == 0) return (false);
         text = StringSubstr(text,index+1);
         index = StringFind(text,",");
         if (index > 0)
         {
            // price
            string pricestring = StringSubstr(text,0,index);
            price = StrToDouble(pricestring);
            if (cmd == OP_BUY) price = Ask;
            else if (cmd == OP_SELL) price = Bid;
            else if (price == 0) return (false);               
            text = StringSubstr(text,index+1);
            index = StringFind(text,",");
            if (index > 0)
            {
               // stoploss
               string stoplossstring = StringSubstr(text,0,index);
               stoploss = StrToDouble(stoplossstring);
               text = StringSubstr(text,index+1);
               index = StringFind(text,",");
               if (index > 0)
               {
                  // takeprofit
                  string takeprofitstring = StringSubstr(text,0,index);
                  takeprofit = StrToDouble(takeprofitstring);
                  text = StringSubstr(text,index+1);
                  if (StringLen(text) > 0)
                  {
                     // Magic number
                     magic = StrToInteger(text);
                     if (magic > 0)
                     {
                        for (int i = 0; i < OrdersTotal(); i++)
                        {
                           OrderSelect(i, SELECT_BY_POS);
                           if (OrderMagicNumber() == magic)
                           {
                              // This trade is already copied beforehand
                              return(false);
                           }
                        }
                        return (true);
                     }
                  }
               }
            }
         }
      }
   }
   return(false);
}

bool ParseSymbolOrderSend(string text, string& symbol, int& cmd, double& volume, double& price, double& stoploss, double& takeprofit, int& magic)
{
   int index = StringFind(text,",");
   text = StringSubstr(text,index+1);
   index = StringFind(text,",");
   if (index > 0)
   {
      // Parse symbol
      symbol = StringSubstr(text,0,index);
      text = StringSubstr(text,index+1);
      index = StringFind(text,",");
      if (index > 0)
      {
         // Parse ordertype
         string cmdstring = StringSubstr(text,0,index);
         if (StringFind(cmdstring,"OP_BUYSTOP") == 0) cmd = OP_BUYSTOP;
         else if (StringFind(cmdstring,"OP_SELLSTOP") == 0) cmd = OP_SELLSTOP;
         else if (StringFind(cmdstring,"OP_BUYLIMIT") == 0) cmd = OP_BUYLIMIT;
         else if (StringFind(cmdstring,"OP_SELLLIMIT") == 0) cmd = OP_SELLLIMIT;
         else if (StringFind(cmdstring,"OP_BUY") == 0) cmd = OP_BUY;
         else if (StringFind(cmdstring,"OP_SELL") == 0) cmd = OP_SELL;
         else return(false);
         text = StringSubstr(text,index+1);
         index = StringFind(text,",");
         if (index > 0)
         {
            // volume
            string volumestring = StringSubstr(text,0,index);
            volume = StrToDouble(volumestring);
            if (volume == 0) return (false);
            text = StringSubstr(text,index+1);
            index = StringFind(text,",");
            if (index > 0)
            {
               // price
               string pricestring = StringSubstr(text,0,index);
               price = StrToDouble(pricestring);
               if (cmd == OP_BUY) price = MarketInfo(symbol,MODE_ASK);
               else if (cmd == OP_SELL) price = MarketInfo(symbol,MODE_BID);
               if (price == 0) return (false);
               text = StringSubstr(text,index+1);
               index = StringFind(text,",");
               if (index > 0)
               {
                  // stoploss
                  string stoplossstring = StringSubstr(text,0,index);
                  stoploss = StrToDouble(stoplossstring);
                  text = StringSubstr(text,index+1);
                  index = StringFind(text,",");
                  if (index > 0)
                  {
                     // takeprofit
                     string takeprofitstring = StringSubstr(text,0,index);
                     takeprofit = StrToDouble(takeprofitstring);
                     text = StringSubstr(text,index+1);
                     if (StringLen(text) > 0)
                     {
                        // Magic number
                        magic = StrToInteger(text);
                        if (magic > 0)
                        {
                           for (int i = 0; i < OrdersTotal(); i++)
                           {
                              OrderSelect(i, SELECT_BY_POS);
                              if (OrderMagicNumber() == magic)
                              {
                                 // This trade is already copied beforehand
                                 return(false);
                              }
                           }
                           return (true);
                        }
                     }
                  }
               }
            }
         }
      }
   }
   return(false);
}

bool ParseOrderModify(string text, int& ticket, double& price, double& stoploss, double& takeprofit)
{
   int index = StringFind(text,",");
   text = StringSubstr(text,index+1);
   index = StringFind(text,",");
   if (index > 0)
   {
      // ticket
      string magicstring = StringSubstr(text,0,index);
      int magic = StrToInteger(magicstring);
      ticket = 0;
      for (int i = 0; i < OrdersTotal(); i++)
      {
         OrderSelect(i, SELECT_BY_POS);
         if (OrderMagicNumber() == magic)
         {
            ticket = OrderTicket();
            break;
         }
      }
      if (ticket == 0) return(false);
      text = StringSubstr(text,index+1);
      index = StringFind(text,",");
      if (index > 0)
      {
         // price
         string pricestring = StringSubstr(text,0,index);
         price = StrToDouble(pricestring);
         text = StringSubstr(text,index+1);
         index = StringFind(text,",");
         if (index > 0)
         {
            // stoploss
            string stoplossstring = StringSubstr(text,0,index);
            stoploss = StrToDouble(stoplossstring);
            text = StringSubstr(text,index+1);
            if (StringLen(text) > 0)
            {
               // takeprofit
               takeprofit = StrToDouble(text);
               return (true);
            }
         }
      }
   }
   return(false);
}

bool ParseOrderClose(string text, int& ticket, double& volume, double& price)
{
   int index = StringFind(text,",");
   text = StringSubstr(text,index+1);
   index = StringFind(text,",");
   if (index > 0)
   {
      // ticket
      string magicstring = StringSubstr(text,0,index);
      int magic = StrToInteger(magicstring);
      ticket = 0;
      for (int i = 0; i < OrdersTotal(); i++)
      {
         OrderSelect(i, SELECT_BY_POS);
         if (OrderMagicNumber() == magic)
         {
            ticket = OrderTicket();
            break;
         }
      }
      if (ticket == 0) return(false);
      text = StringSubstr(text,index+1);
      if (StringLen(text) > 0)
      {
         // volume
         volume = StrToDouble(text);
         if (volume == 0) return(false);
         if (OrderSelect(ticket,SELECT_BY_TICKET))
         {
            if (volume == -1) volume = OrderLots();
            if (OrderType() == OP_BUY)
            {
               price = Bid;
               return(true);
            }
            else if (OrderType() == OP_SELL)
            {
               price = Ask;
               return(true);
            }
         }
      }
   }
   return(false);
}

bool ParseOrderDelete(string text, int& ticket)
{
   int index = StringFind(text,",");
   text = StringSubstr(text,index+1);
   if (StringLen(text) > 0)
   {
      // ticket
      int magic = StrToInteger(text);
      ticket = 0;
      for (int i = 0; i < OrdersTotal(); i++)
      {
         OrderSelect(i, SELECT_BY_POS);
         if (OrderMagicNumber() == magic)
         {
            ticket = OrderTicket();
            break;
         }
      }
      if (ticket > 0) return(true);
   }
   return(false);
}

